"use strict";
/**
 * Base interface class other can inherits from
 */
Object.defineProperty(exports, "__esModule", { value: true });
class UI {
    constructor() {
        Object.defineProperty(this, "onClose", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.onForceClose = this.onForceClose.bind(this);
        // Make sure new prompt start on a newline when closing
        process.on('exit', this.onForceClose);
    }
    /**
     * Handle the ^C exit
     */
    onForceClose() {
        this.close();
        process.kill(process.pid, 'SIGINT');
        console.log('');
    }
    /**
     * Close the interface and cleanup listeners
     */
    close() {
        // Remove events listeners
        process.removeListener('exit', this.onForceClose);
        if (typeof this.onClose === 'function') {
            this.onClose();
        }
    }
}
exports.default = UI;
